BeanDescription (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map

## Class BeanDescription

- java.lang.Object
- - org.codehaus.jackson.map.BeanDescription

- Direct Known Subclasses:
    BasicBeanDescription

      public abstract class BeanDescription
      extends Object

  Basic container for information gathered by `ClassIntrospector` to help in constructing serializers and deserializers. Note that the main implementation type is `BasicBeanDescription`, meaning that it is safe to upcast to this type.
  Author:
    tatu

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_type` Bean type information, including raw class and possible * generics information

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BeanDescription(JavaType type)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract TypeBindings` | `bindingsForBeanType()` Accessor for type bindings that may be needed to fully resolve types of member object, such as return and argument types of methods and constructors, and types of fields.
    `abstract AnnotatedMethod` | `findAnyGetter()`
    `abstract AnnotatedMethod` | `findAnySetter()`
    `abstract AnnotatedConstructor` | `findDefaultConstructor()`
    `abstract LinkedHashMap<String,AnnotatedField>` | `findDeserializableFields(VisibilityChecker<?> visibilityChecker, Collection<String> ignoredProperties)` Deprecated. Since 1.9 use `findProperties()`
    `abstract LinkedHashMap<String,AnnotatedMethod>` | `findGetters(VisibilityChecker<?> visibilityChecker, Collection<String> ignoredProperties)` Deprecated. Since 1.9 use `findProperties()`
    `abstract Map<Object,AnnotatedMember>` | `findInjectables()`
    `abstract AnnotatedMethod` | `findJsonValueMethod()`
    `abstract List<BeanPropertyDefinition>` | `findProperties()`
    `abstract Map<String,AnnotatedField>` | `findSerializableFields(VisibilityChecker<?> visibilityChecker, Collection<String> ignoredProperties)` Deprecated. Since 1.9 use the non-deprecated version
    `abstract LinkedHashMap<String,AnnotatedMethod>` | `findSetters(VisibilityChecker<?> visibilityChecker)` Deprecated. Since 1.9 use `findProperties()`
    `Class<?>` | `getBeanClass()`
    `abstract Annotations` | `getClassAnnotations()` Method for accessing collection of annotations the bean class has.
    `abstract AnnotatedClass` | `getClassInfo()`
    `abstract Set<String>` | `getIgnoredPropertyNames()`
    `JavaType` | `getType()` Method for accessing declared type of bean being introspected, including full generic type information (from declaration)
    `abstract boolean` | `hasKnownClassAnnotations()`
    `abstract JavaType` | `resolveType(Type jdkType)` Method for resolving given JDK type, using this bean as the generic type resolution context.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _type

          protected final JavaType _type

      Bean type information, including raw class and possible * generics information

  - ### Constructor Detail

    - #### BeanDescription

          protected BeanDescription(JavaType type)

  - ### Method Detail

    - #### getType

          public JavaType getType()

      Method for accessing declared type of bean being introspected, including full generic type information (from declaration)

    - #### getBeanClass

          public Class<?> getBeanClass()

    - #### getClassInfo

          public abstract AnnotatedClass getClassInfo()

    - #### hasKnownClassAnnotations

          public abstract boolean hasKnownClassAnnotations()

    - #### bindingsForBeanType

          public abstract TypeBindings bindingsForBeanType()

      Accessor for type bindings that may be needed to fully resolve types of member object, such as return and argument types of methods and constructors, and types of fields.

    - #### resolveType

          public abstract JavaType resolveType(Type jdkType)

      Method for resolving given JDK type, using this bean as the generic type resolution context.
      Since:
        1.9

    - #### getClassAnnotations

          public abstract Annotations getClassAnnotations()

      Method for accessing collection of annotations the bean class has.
      Since:
        1.7

    - #### findProperties

          public abstract List<BeanPropertyDefinition> findProperties()

      Returns:
        Ordered Map with logical property name as key, and matching getter method as value.
      Since:
        1.9

    - #### findInjectables

          public abstract Map<Object,AnnotatedMember> findInjectables()

      Since:
        1.9

    - #### findAnyGetter

          public abstract AnnotatedMethod findAnyGetter()

      Since:
        1.9

    - #### findAnySetter

          public abstract AnnotatedMethod findAnySetter()

      Since:
        1.9

    - #### findJsonValueMethod

          public abstract AnnotatedMethod findJsonValueMethod()

      Since:
        1.9

    - #### findDefaultConstructor

          public abstract AnnotatedConstructor findDefaultConstructor()

      Since:
        1.9

    - #### getIgnoredPropertyNames

          public abstract Set<String> getIgnoredPropertyNames()

      Since:
        1.9

    - #### findGetters

          @Deprecated
          public abstract LinkedHashMap<String,AnnotatedMethod> findGetters(VisibilityChecker<?> visibilityChecker,
                                                                     Collection<String> ignoredProperties)

      Deprecated. Since 1.9 use `findProperties()`

    - #### findSetters

          @Deprecated
          public abstract LinkedHashMap<String,AnnotatedMethod> findSetters(VisibilityChecker<?> visibilityChecker)

      Deprecated. Since 1.9 use `findProperties()`

    - #### findDeserializableFields

          @Deprecated
          public abstract LinkedHashMap<String,AnnotatedField> findDeserializableFields(VisibilityChecker<?> visibilityChecker,
                                                                                 Collection<String> ignoredProperties)

      Deprecated. Since 1.9 use `findProperties()`

    - #### findSerializableFields

          @Deprecated
          public abstract Map<String,AnnotatedField> findSerializableFields(VisibilityChecker<?> visibilityChecker,
                                                                     Collection<String> ignoredProperties)

      Deprecated. Since 1.9 use the non-deprecated version